//post_test.c
//

//.\lcc -target=xr18CX "-Wa -D STACKLOC=0xEEEE" "-Wa -D NOFILLBSS=1 " "-Wa -D DATALOC=0xC000" "-Wa -D CPUSPEED=5000000" post_test.c -o post_test.hex "-Wf -volatile -cpu1805" "-DSCC=1" "-DDEBUG=0"
#include <nstdlib.h>
#include "olduino.h"
#include <rand.h>
void sccDEFAULT();
#include "SPI.h"
#define NULL 0x00
#include <1806.h>
#include <EF.h>

#if(SCC == 0)
#define putc(x) putcser(x)
unsigned char getcser();
#define getc() getcser()
void putcser(unsigned char);
#endif

#if(SCC == 1)
#include "scc.h"
#define putc(x) sccOUT(x);
#define getc() sccIN()
void sccOUT(char);
char sccIN();
#endif


void main(){
	char c;
	int i;
	out(1,0x03);
    out(2,0x80); //10010001 //so port C bits 0-3 are inputs for setting or quiting code
	out(3,0x80);
	out(4,0x80); //IO 4 is now having its port A as bidirectional <-> 1100 0000 0xC0
    out(1,0x00);
 #if(SCC == 1 || SCC == 2)
    out(1,0x01);//select port b
    out(4,0x02); //CRA
    out(6,0x10); // 00010000 set pointer to MR1A
    out(4,0x00); //adress 00 //MR1A//MR2A
    out(6,0x53); //0101 0011 decimal 83 hex 0x53
    out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal
    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101
    out(4,0x01); //csra
    out(6,0xBB); //0100 0100 300 bound but in test mode wich is the one we use, its 28.8Kboundrate       //9600 bound rate is 1011 1011 we use 9600 for now 18/11/2023
    out(4,0x05); //R5 :: IMR interrupt mask register
    out(6,0x02);//0000 0010 //for when only Rx of channel A is ready
    out(4,0x02); //CRA
    out(6,0x05); // 0000 0101
    inp(6); //read register two wich changes to BRGTEST, to make it from 300 bound to 28.8Kboundrate
	out(4,0x04);
	out(6,0x80); //set ACR[7]=1, set to 0x00 for ACR[7]=0
    delay(1000);
	
	out(1,0x01);
	out(4,0x01);
	if(!(inp(6)&0x04)){
		
		//test if we ready to send data
		i=0xFF;
		while(i){
			if(inp(6)&0x04){
			
				printf("Info:SCC exception 0x00\r\n");
				break; //if sucessfull we can TX, but emit warning
				
			}
		}
		
		if(i=0){ //but if failed
			
			while(1){
				delay(500);
				asm("	seq\n");
				delay(500);
				asm("	req\n");
				
			}
			
		}
		
	}

	printf("channel 1 ON \r\n");
	
	printf("IO test...");
	out(1,0x03);
	if(inp(2)){
		printf("IO2 OK;");
	}
	out(1,0x03);
	if(inp(3)){
		printf("IO3 OK;");
	}
	out(1,0x03);
	if(inp(4)){
		printf("IO4 OK;");
	}
	printf("\r\n");
	
	printf("RTC check...");
	out(1,0x01);
	out(4,0x0D);
	c=inp(7);
	
	if(c&0x01){
		printf("Battery OK;");
	}else{printf("Battery BAD;");}
	
	if(c&0x02){
		printf("Warning: VCC transient.");
	}
	printf("\r\n");
	
	printf("End of basic P.O.S.T. test.\r\n");
	
	while(1){
		
		asm("	seq\n");
		delay(500);
		asm("	req\n");
		delay(1500);
		
	}
	
}

#include <olduino.c>
#include <stdlib.c>
#if(SCC == 0)
void includeser2()
{
    asm("BAUDRATE EQU 	9600\n");
    asm(" include xrwjrT3.inc\n");
    asm(" include serwjrT3.inc\n");
}
#endif

